//For details see:
//https://homofaciens.de/technics-machines-3D-printer-Zonestar-Printer_ge.htm

$fn=100;
M3_teight = 2.8;
M4 = 4.5;

tube_e = 20;

buckles_h = 2;
buckles_w = 5;
buckles_r = 60;
buckles_shift = 6;

//Pen park dimensions
pp_wall = 3;
pp_d_i = 36;
pp_d_o = 60;
pp_gap = 40;
pp_l = 70;
pp_w = 46.5*2+pp_gap;
pp_h = 20;
pp_m_dis_1 = 50;
pp_m_dis_2 = 110;

//Lift lever
ll_pivot = 65;

pen_d = 20;
gripper_w = 20;
gripper_l = 60;
gripper_pivot = 45;
gripper_wall = 5;

show_bearing = 0;
show_pen = 0;


rotate([0, 0, 0]){
//  pen_holder_simple();
}


translate([200, 0, 0]){
  //rotate([90, 45, 0]){
    //pen_park();
  //}
}

translate([0, 0, 0]){
  //rotate([90, 45, 0]){
//    pen_park_mount();
  //}
}
translate([-60, 0, 0]){
  mirror([1, 0, 0]){
//    pen_park_mount();
  }
}

pen_holder_advanced(1);
translate([55, 0, 0]){
  pen_holder_advanced(2);
}


translate([0, 80, 22*0]){
  //rotate([90, 45, 0]){
    //pen_stopper();
  //}
}


translate([0, 0, 0]){
  //pen_fixture();
}

translate([0, 0, 0]){
  //square_tube(st_pen=16, st_cap_l=22, st_cap_d=17.5);
  //square_tube(st_pen=8, st_cap_l=22, st_cap_d=12);
}


for(i=[3:1:8]){
  translate([12*i, 0, 0]){
//    z_switch_screw_spacer(h1=i*5);
  }
}


translate([0, 0, 0]){
  //relay_mount();
}


translate([0, 0, 0]){
  //printer_addon();
}
translate([50, 0, 0]){
//  lever_stopper();
}

//translate([6.5*1, 42.5*1+10.5, 57*1]){
//  rotate([-13, 0, 0])
//  rotate([0, -90*1, 90*0]){
//    lever();
//  }
//}

mirror([0,1, 0]){
//  T_shirt_clamp();
}

module T_shirt_clamp(){
  bottom_grove = 3.5;
  top_grove = 4.5;
  tc_wall = 3;
  tc_h = 35;
  tc_edge = 15;
  tc_w = 20;
  tc_flap = 20;
  
  translate([0, 0, tc_w/2]){
    difference(){
      cube(size=[tc_h+2*tc_wall, tc_edge+tc_wall, tc_w], center=true);
      a=tc_h-bottom_grove-top_grove-2*tc_wall;
      translate([(top_grove-bottom_grove)/2, tc_wall, 0]){
        cube(size=[a, tc_edge+tc_wall, tc_w*1.1], center=true);
      }
      translate([(tc_h-bottom_grove)/2, tc_wall, 0]){
        cube(size=[bottom_grove, tc_edge+tc_wall, tc_w*1.1], center=true);
      }
      translate([-(tc_h-top_grove)/2, tc_wall, 0]){
        cube(size=[top_grove, tc_edge+tc_wall, tc_w*1.1], center=true);
      }
    }
    translate([(tc_h-tc_wall)/2-bottom_grove, 0, (tc_w+tc_flap)/2]){
      cube(size=[tc_wall, tc_edge+tc_wall, tc_flap], center=true);
    }
  }
  
  
  
  
}

module printer_addon(){
  tm_width = 34;
  tm_wall = 5;
  tm_height = 100;
  c_h = 35;
  mount_screws_distance = 31;
  mount_screws_height = 25;
  
  difference(){
    union(){
      translate([0, 0, tm_wall/4]){
        cube(size=[tm_width, tm_height-2*c_h, tm_wall/2], center=true);
      }
      translate([0, (tm_height-c_h)/2, 0]){
        clamp_dummy(52, c_h, type=1);
      }
      translate([0, -(tm_height-c_h)/2, 0]){
        clamp_dummy(52, c_h, s_shift = -9);
      }
      a = tm_wall;
      b = tm_height-2*c_h+5;
      c = 10;
      d = (tm_width-tm_wall)/2;
      translate([d, b/2-2.5, tm_wall/2]){
        linear_extrude(height=ll_pivot, scale=[1, 0.01]){
          translate([0, -b/2, 0]){
            square(size=[a, b], center=true);
          }
        }
      }
      translate([-d, b/2-2.5, tm_wall/2]){
        linear_extrude(height=ll_pivot, scale=[1, 0.01]){
          translate([0, -b/2, 0]){
            square(size=[a, b], center=true);
          }
        }
      }
    }
    //Mount screw holes
    translate([mount_screws_distance/2, mount_screws_height-tm_height/2, tm_wall/2]){
      cylinder(d=8, h=10, center=true);
    }
    translate([-mount_screws_distance/2, mount_screws_height-tm_height/2, tm_wall/2]){
      cylinder(d=8, h=10, center=true);
    }
  }


}

module lever_stopper(){
  ls_w = 29-5;
  ls_h = 15;
  ls_flap = 10;
  ls_wall = 5;

  difference(){
    union(){  
      translate([0, 0, ls_wall/2]){
        cube(size=[ls_w, ls_h, ls_wall], center=true);
      }
      translate([0, 0, ls_flap/2]){
        cube(size=[ls_w, ls_h, ls_flap], center=true);
      }
      translate([0, 0, ls_flap]){
        rotate([0, 90, 0]){
          cylinder(d=ls_h, h=ls_w, center=true);
        }
      }
    }
    translate([0, 0, ls_flap]){
      rotate([0, 90, 0]){
        cylinder(d=M4, h=ls_w*1.1, center=true);
      }
    }
      translate([0, 0, -ls_wall/2]){
        cube(size=[ls_w*1.1, ls_h, ls_wall], center=true);
      }
  }
  
}

module clamp_dummy(c_w = 60, c_h = 20, s_shift = 0, type=0){
  c_wall = 5;
  c_screw_d = c_w-8;
  ll_mount_w = 29;
  ll_mount_edge = 35;
  ll_mount_l = ll_pivot + ll_mount_edge;
  ll_mount_r = 5;
  socket = 35;
  //filament tube mount
  ft_w = 20;
  z_shift = 30;
  pivot_z_shift = 30;
  tube_mount_shift_z = 5;
  
  difference(){
    union(){
      translate([0, 0, c_wall/4]){
        round_cube(c_w, c_h, c_wall/2, 6);
      }
      if(type == 1){
        translate([ll_mount_w/2, z_shift/2, 0]){
          translate([0, 0, ll_mount_l-ll_mount_r/2]){
            a=c_wall;
            b=c_h-2*ll_mount_r+z_shift;
            c=ll_mount_r;
            cube(size=[a, b, c], center=true);
          }
          ty=(c_h-2*ll_mount_r+z_shift)/2;
          tz=ll_mount_l-ll_mount_r;
          translate([0, ty, tz]){
            rotate([0, 90, 0]){
              cylinder(r=ll_mount_r, c_wall, center=true);
            }
          }
          translate([0, -ty, tz]){
            rotate([0, 90, 0]){
              cylinder(r=ll_mount_r, c_wall, center=true);
            }
          }
          translate([0, 0, (ll_mount_l-c_wall/2)/2]){
            a=c_wall;
            b=c_h+z_shift;
            c=ll_mount_l-ll_mount_r-c_wall/2;
            cube(size=[a, b, c], center=true);
          }
        }
        translate([-ll_mount_w/2, z_shift/2, 0]){
          translate([0, 0, ll_mount_l-ll_mount_r/2]){
            a=c_wall;
            b=c_h-2*ll_mount_r+z_shift;
            c=ll_mount_r;
            cube(size=[a, b, c], center=true);
          }
          ty=(c_h-2*ll_mount_r+z_shift)/2;
          tz=ll_mount_l-ll_mount_r;
          translate([0, ty, tz]){
            rotate([0, 90, 0]){
              cylinder(r=ll_mount_r, c_wall, center=true);
            }
          }
          translate([0, -ty, tz]){
            rotate([0, 90, 0]){
              cylinder(r=ll_mount_r, c_wall, center=true);
            }
          }
          translate([0, 0, (ll_mount_l-c_wall/2)/2]){
            a=c_wall;
            b=c_h+z_shift;
            c=ll_mount_l-ll_mount_r-c_wall/2;
            cube(size=[a, b, c], center=true);
          }
        }


        //Filament tube mount
        ty=(c_h-c_wall)/2+z_shift;
        tz=ll_mount_l-ft_w/2-ll_mount_w/4-tube_mount_shift_z;
        translate([0, ty, tz]){
          a=ll_mount_w-c_wall;
          b=c_wall;
          c=ft_w+ll_mount_w/2;
          cube(size=[a, b, c], center=true);
        }
        
      }
    }
    //Screw holes
    translate([-c_screw_d/2, s_shift, c_wall/2]){
      cylinder(d=M4, h=c_wall*1.1, center=true);
    }
    translate([c_screw_d/2, s_shift, c_wall/2]){
      cylinder(d=M4, h=c_wall*1.1, center=true);
    }
    //pivot hole
    translate([0, pivot_z_shift, ll_pivot]){
      rotate([0, 90, 0]){
        long_hole(diameter = M4, length = 10, height = ll_mount_w*2);
      }
    }
    //Filament tube mount
    translate([0, z_shift, ll_mount_l-ft_w/2-tube_mount_shift_z]){
      rotate([90, 0, 0]){
        cylinder(d=5.5, h=ll_mount_w*2, center=true);
      }
    }
    //triangular cut
    translate([0, (c_h-c_wall)/2+z_shift, ll_mount_l-ft_w-ll_mount_w/2-tube_mount_shift_z]){
      rotate([0, 45, 0]){
        a=(ll_mount_w-c_wall)/2;
        b=sqrt(2*a*a);
        cube(size=[b, c_wall*2, b], center=true);
      }
    }
    //Long hole stopper
    translate([0, 0, ll_mount_l-ft_w/2-tube_mount_shift_z+5]){
      rotate([90, 0, 90]){
        long_hole(diameter=4.5, length=20, height=c_w);
      }
    }
    //shift cut
    translate([0, (c_h+z_shift)/2+0.1, socket/2]){
      cube(size=[ll_mount_w*1.5, z_shift+0.2, socket], center=true);
      b=sqrt(2*z_shift*z_shift);
      translate([0, z_shift/2, socket/2]){
        rotate([45, 0, 0]){
          cube(size=[ll_mount_w*1.5, b, b], center=true);
        }
      }
    }
  }
}

module lever(){
  l_wall = 5;
  l_wall_2 = 1.5;
  l_w = 15.5;
  l_l1 = 70;
  l_l2 = 25;
  ll_mount_edge = 25;
  pivot_d = 20;
  pivot_shift = 7.5;
  l_stair = 10;
  l2_angle = 13.5;
  
  difference(){
    union(){
      translate([0, l_wall/2, l_w/2]){
        cube(size=[l_l1, l_wall*2, l_w], center=true);
      }
      translate([-l_l1/2, (l_stair-l_wall)/2, l_w/2]){
        cube(size=[l_wall, l_stair, l_w], center=true);
      }
      translate([(-l_l1-l_l2)/2, l_stair-(l_wall+l_wall_2)/2+2.5, l_w/2]){
        rotate([0, 0, -l2_angle]){
          cube(size=[l_l2, l_wall_2, l_w], center=true);
        }
      }
      translate([l_l1/2, l_wall/2, l_w/2]){
        rotate([90, 0, 0]){
          cylinder(d=l_w, h=l_wall*2, center=true);
        }
      }
      translate([l_l1/2-ll_mount_edge, pivot_shift, l_w/2]){
        cylinder(d=pivot_d*0.7, h=l_w, center=true);
      }
    }
    translate([l_l1/2-ll_mount_edge, pivot_shift, l_w/2]){
      cylinder(d=M4, h=l_w*1.1, center=true);
    }
    translate([l_l1/2-5, l_wall*1.5, l_w/2]){
      rotate([90, 0, 0]){
        long_hole(diameter = 13, length = 10, height = l_wall*2);
      }
    }
  }
}


module relay_mount(){
  rm_wall = 2;
  rm_l = 35+2*rm_wall;
  rm_w = 28+2*rm_wall;
  rm_w2 = 20;
  rm_h = 14;
  rm_h2 = 4;
  
  rail_w = 5;
  
  ink_d = 20;
  ink_h = 30;
  ink_h2 = 15;
  ink_hole = 1.7;
  ink_hole2 = 2.2;
  ink_pos_x = (rm_l+ink_d)/2+rm_wall + 1;
  ink_wall = 3.5;
  ink_slit_w = 1.5;
  ink_slit_h = 5;
  brim_h = 0.35;
  
  //Supports relay mount
  s_distance = rm_w/11;
  for(i=[0:s_distance:rm_w+0.01]){
    translate([0, rm_w/2-i]){
      support(s_l = rm_l, s_w = 0.5, s_h = ink_d/2, brim_h=0.35);
    }
  }
  rotate([0, 0, 90]){
    for(i=[0:rm_l:rm_l]){
      translate([0, rm_l/2-i]){
        support(s_l = rm_w, s_w = 0.5, s_h = ink_d/2, brim_h=0);
      }
    }
  }
  
  //Relay mount
  translate([0, 0, rm_h/2+ink_d/2]){
    difference(){
      union(){
        cube(size=[rm_l, rm_w, rm_h], center=true);
        translate([rm_l/2, 0, 0]){
          cube(size=[5, 10, rm_h], center=true);
        }
        //side rails
        translate([0, rm_w/2, 0]){
          rotate([45, 0, 0]){
            cube(size=[rm_l, rail_w, rail_w], center=true);
          }
        }
        translate([0, -rm_w/2, 0]){
          rotate([45, 0, 0]){
            cube(size=[rm_l, rail_w, rail_w], center=true);
          }
        }
        
      }
      //Cut tip of side rails
      translate([0, rm_w/2+5, 0]){
        cube(size=[rm_l*1.1, rail_w, rail_w], center=true);
      }
      translate([0, -rm_w/2-5, 0]){
        cube(size=[rm_l*1.1, rail_w, rail_w], center=true);
      }
      translate([rm_l/2, -rm_w/2-4, 0]){
        rotate([0, 0, 45]){
          cube(size=[5, 5, 10], center=true);
        }
      }
      translate([-rm_l/2, -rm_w/2-4, 0]){
        rotate([0, 0, 45]){
          cube(size=[5, 5, 10], center=true);
        }
      }
      translate([0, -rm_w/2-4, 0]){
        rotate([0, 0, 45]){
          cube(size=[5, 5, 10], center=true);
        }
      }

      translate([rm_l/2, rm_w/2+4, 0]){
        rotate([0, 0, 45]){
          cube(size=[5, 5, 10], center=true);
        }
      }
      translate([-rm_l/2, rm_w/2+4, 0]){
        rotate([0, 0, 45]){
          cube(size=[5, 5, 10], center=true);
        }
      }
      translate([0, +rm_w/2+4, 0]){
        rotate([0, 0, 45]){
          cube(size=[5, 5, 10], center=true);
        }
      }
      
      //Cut inner area
      translate([0, 0, rm_wall]){
        cube(size=[rm_l-2*rm_wall, rm_w2, rm_h], center=true);    
      }
      translate([0, 0, rm_h2]){
        cube(size=[rm_l-2*rm_wall, rm_w-2*rm_wall, rm_h], center=true);
      }
      //cut rear wall
      translate([-rm_wall/2-0.1, 0, rm_h2]){
        cube(size=[rm_l-rm_wall+0.2, rm_w-2*rm_wall-7, rm_h], center=true);
      }
    }
  }
  //Bottom cone ink tank
  translate([ink_pos_x, 0, ink_d/4]){
    difference(){
      union(){
        cylinder(d=rm_wall, h=ink_d/2, d2=ink_d+2*rm_wall, center=true);
        //Brim
        translate([0, 0, brim_h/2-ink_d/4]){
          cylinder(d=20, h=brim_h, center=true);
        }
      }
      translate([0, 0, rm_wall]){
        cylinder(d=rm_wall, h=ink_d/2, d2=ink_d+2*rm_wall, center=true);
      }
      translate([0, 0, -ink_d/4]){
        cylinder(d=ink_hole, h=ink_h, center=true);
      }
    }
  }
  
  //Cylinder ink tank
  translate([ink_pos_x, 0, ink_d/2]){
    difference(){
      union(){
        translate([0, 0, ink_h/2]){
          cylinder(d=ink_d+2*rm_wall, h=ink_h, center=true);
        }
      }
      translate([0, 0, ink_h/2]){
        cylinder(d=ink_d, h=ink_h*1.1, center=true);
      }
      translate([-15, 0, ink_h/2+ink_h2]){
        cube(size=[ink_d*2, ink_d*2, ink_h], center=true);
      }
      translate([0, 0, ink_h2+((ink_h-ink_h2)-rm_wall)/2]){
        cube(size=[ink_d*2, rm_wall, (ink_h-ink_h2)-rm_wall], center=true);
      }
    }
  }
  //Inner wall ink tank
  translate([ink_pos_x, 0, ink_d/2]){
    difference(){
      mirror([0, 0, 1])
      union(){
        linear_extrude(height=ink_d/2, scale=[0.01, 1]){
          square(size=[ink_d, ink_wall], center=true);
        }
        translate([0, 0, -ink_h2/2]){
          cube(size=[ink_d, ink_wall, ink_h2], center=true);    
        }
      }
      cylinder(d=ink_hole2, h=ink_h*2, center=true);
      translate([0, 0, (ink_slit_h-ink_d)/2]){
        cube(size=[ink_slit_w, ink_wall*1.1, ink_slit_h], center=true);    
      }
    }
  }
  
  
}

module support(s_l = 50, s_w = 2, s_h = 5, brim_w = 5, brim_h=0.35){
  
  if(brim_h > 0 && brim_w > 0){
    translate([0, 0, brim_h/2]){
      cube(size=[s_l, brim_w, brim_h], center=true);
    }
  }

  translate([0, 0, (s_h-s_w)/2]){
    cube(size=[s_l, s_w, s_h-s_w], center=true);
  }
  translate([0, 0, s_h-s_w]){
    linear_extrude(height=s_w, scale=[1, 0.1]){
      square(size=[s_l, s_w], center=true);
    }
  }
  
}

module z_switch_screw_spacer(do = 7, di = 2.8, h1 = 5, h2=3){
  brim_h = 0.35;

  translate([0, 0, h1+h2/2]){
    cylinder(d=di, h=h2, center=true);
  }
  translate([0, 0, h1/2]){
    difference(){
      union(){
        cylinder(d=do, h=h1, center=true);
        translate([0, 0, (brim_h-h1)/2]){
          cylinder(d=do*3, h=brim_h, center=true);
        }
      }
      translate([0, 0, -1]){
        cylinder(d=di, h=h1, center=true);
      }
    }
  }

}


module square_tube(st_edge=20, st_pen=8.5, st_cap_d=8.5*1.5, st_l=125, st_cap_l=22){
  
  translate([0, 0, st_edge/2]){
      difference(){
          union(){
            cube(size=[st_edge, st_l, st_edge], center=true);
        }
        rotate([90, 0, 0]){
          cylinder(d=st_pen, h=st_l*1.1, center=true);
          translate([0, 0, -st_l+st_cap_l]){
            cylinder(d=st_cap_d, h=st_l, center=true);
          }
        }
      }
  }
  
  
}



module pen_fixture(pf_edge=16, pf_pen=8, pf_l=60, pf_cap_l=22){
  pf_gap = 2;
  pf_stop = 1;
  
  translate([0, 0, pf_edge/2]){
    rotate([0, -45, 0]){
      difference(){
        rotate([0, 45, 0]){
          union(){
            cube(size=[pf_edge, pf_l, pf_edge], center=true);
            translate([0, pf_l/2, 0]){
              rotate([270, 0, 0]){
                linear_extrude(height = 1, scale=0.95){
                  square(size=[pf_edge+2, pf_edge], center=true);
                }
              }
            }
          }
        }
        translate([0, 0, pf_edge-pf_gap/2]){
          cube(size=[pf_edge*2, pf_l*1.1, pf_edge*2], center=true);
        }
        rotate([90, 0, 0]){
          cylinder(d=pf_pen, h=pf_l*1.1, center=true);
          translate([0, 0, -pf_l+pf_cap_l]){
            cylinder(d=pf_pen*1.5, h=pf_l, center=true);
          }
        }
      }
    }
  }
  
  
}

module pen_park_mount(){
  ppm_screw_dis = 35;
  ppm_screw_edge = 15;
  ppm_l1 = 200;
  ppm_l2 = 90;
  ppm_h1 = 15;
  ppm_h2 = 25 + ppm_h1;
  ppm_wall = 5;
  ppm_round = 10;
  pp_m_dis_1 = 50;
  pp_edge = 13;
  
  difference(){
    union(){
      translate([0, 0, ppm_wall/2]){
        round_cube(ppm_h2, ppm_l2, ppm_wall, ppm_round);
      }
      translate([-(ppm_h2-ppm_h1)/2, (ppm_l1-ppm_round-ppm_l2)/2+ppm_round, ppm_h1/2]){
        cube(size=[ppm_h1, ppm_l1-ppm_round-ppm_h1, ppm_h1], center=true);
        translate([0, (ppm_l1-ppm_round-ppm_h1)/2, 0]){
          rotate([0, 90, 0]){
            cylinder(d=ppm_h1, h=ppm_h1, center=true);
          }
        }
        translate([0, -(ppm_l1-ppm_round-ppm_h1)/2, 0]){
          rotate([0, 90, 0]){
            cylinder(d=ppm_h1, h=ppm_h1, center=true);
          }
        }
      }
    }
    //Mount holes pen park
    translate([ppm_h2/2-pp_edge, pp_m_dis_1/2, ppm_wall/2]){
      rotate([0, 0, 90]){
        long_hole(diameter = M4, length = 15, height = 6);
      }
    }
    translate([ppm_h2/2-pp_edge, -pp_m_dis_1/2, ppm_wall/2]){
      rotate([0, 0, 90]){
        long_hole(diameter = M4, length = 15, height = 6);
      }
    }
    //Mount holes printer frame
    translate([-(ppm_h2-ppm_h1)/2, ppm_l1-ppm_l2/2-ppm_screw_edge, ppm_h1/2]){
      rotate([0, 90, 0]){
        cylinder(d=M4, h=ppm_h1*1.1, center=true);
      }
    }
    translate([-(ppm_h2-ppm_h1)/2, ppm_l1-ppm_l2/2-ppm_screw_edge-ppm_screw_dis, ppm_h1/2]){
      rotate([0, 90, 0]){
        cylinder(d=M4, h=ppm_h1*1.1, center=true);
      }
    }

    translate([-ppm_h2/2+ppm_h1*1.5-5, ppm_l1-ppm_l2/2-ppm_screw_edge, ppm_h1/2]){
      rotate([0, 90, 0]){
        cylinder(d=M4*2, h=ppm_h1, center=true);
      }
    }
    translate([-ppm_h2/2+ppm_h1*1.5-5, ppm_l1-ppm_l2/2-ppm_screw_edge-ppm_screw_dis, ppm_h1/2]){
      rotate([0, 90, 0]){
        cylinder(d=M4*2, h=ppm_h1, center=true);
      }
    }

  }
    
}

module pen_park(left_wall = 5){
  
  difference(){
    union(){
      translate([0, 0, pp_wall/2]){
        cube(size=[pp_l, pp_w, pp_wall], center=true);
      }
      //Walls
      translate([(pp_l-pp_wall)/2, 0, pp_wall+pp_h/2]){
        cube(size=[pp_wall, pp_w, pp_h], center=true);
      }
      translate([-(pp_l-pp_wall)/2, 0, pp_wall+pp_h/2]){
        cube(size=[pp_wall, pp_w, pp_h], center=true);
      }
      translate([0, (pp_w-pp_wall+left_wall)/2, pp_wall/2+pp_h/2]){
        cube(size=[pp_l, pp_wall+left_wall, pp_h+pp_wall], center=true);
      }
      translate([0, -(pp_w-pp_wall)/2, pp_wall+pp_h/2]){
        cube(size=[pp_l-pp_wall, pp_wall, pp_h], center=true);
      }
    }
    //Mount holes
    translate([pp_m_dis_1/2, 0, pp_wall+pp_h/2]){
      rotate([90, 0, 0]){
        cylinder(d=M4, h=pp_w*1.1, center=true);
      }
    }
    translate([-pp_m_dis_1/2, 0, pp_wall+pp_h/2]){
      rotate([90, 0, 0]){
        cylinder(d=M4, h=pp_w*1.1, center=true);
      }
    }
    translate([0, pp_m_dis_2/2, pp_wall+pp_h/2]){
      rotate([0, 90, 0]){
        cylinder(d=M4, h=pp_w*1.1, center=true);
      }
    }
    translate([0, -pp_m_dis_2/2, pp_wall+pp_h/2]){
      rotate([0, 90, 0]){
        cylinder(d=M4, h=pp_w*1.1, center=true);
      }
    }
    //Center cut
    translate([0, 0, pp_wall/2]){
      cube(size=[pp_d_o, pp_gap, pp_wall*1.1], center=true);
    }
    for(i=[0:1:1]){
      mirror([0, i, 0]){
        translate([0, -(pp_gap/2+25), 0]){
          rotate([0, 0, 45]){
            scale([1.04, 1.04]){
              translate([0, 0, pp_wall/2]){
                pen_stopper();
              }
            }
          }
          translate([0, 0, pp_wall/2]){
            cylinder(d=pp_d_i, h=pp_wall*1.1, center=true);
          }
          translate([0, pp_d_i/2, pp_wall/2]){
            cube(size=[pp_d_i, pp_d_i, pp_wall*1.1], center=true);
          }
        }
      }
    }
  }
  
}

module pen_stopper(){
  ps_wall = 3;
  ps_d_o = 50;
  ps_d_i = 35;
  ps_h = 20;
  
  difference(){
    union(){
      translate([0, 0, ps_wall/2]){
        cylinder(d=ps_d_o, h=ps_wall, center=true);
      }
      translate([0, 0, ps_h/2]){
        cylinder(d=ps_d_i, h=ps_h, center=true);
      }
    }
    translate([0, 0, ps_h/2]){
      cube(size=[tube_e, tube_e, ps_h*1.1], center=true);
    }
    rotate([0, 0, 45]){
      translate([(ps_d_i+ps_d_o)/2, 0, ps_h/2]){
        cube(size=[ps_d_o, ps_d_o, ps_h*1.1], center=true);
      }
      translate([-(ps_d_i+ps_d_o)/2, 0, ps_h/2]){
        cube(size=[ps_d_o, ps_d_o, ps_h*1.1], center=true);
      }
    }
  }
}

module pen_holder_simple(){
  tm_edge = 12*0;
  tm_width = 50;
  tm_wall = 5;
  tm_height = 80+10*0;
  pr_wall = 5;
  pr_height = 15;
  mount_screws_distance = 31;
  mount_screws_height = 20-10*0;
  
  translate([0, 0, tm_wall/2]){
    difference(){
      union(){
        round_cube(tm_width, tm_height, tm_wall, 10);
        translate([0, (tm_height-pr_height)/2, pen_d/2+pr_wall]){
          rotate([0, 90, 90]){
            cylinder(d=pen_d+2*pr_wall, h=pr_height, center=true);
          }
        }
        translate([0, tm_edge-(tm_height-pr_height)/2, pen_d/2+pr_wall]){
          rotate([0, 90, 90]){
            cylinder(d=pen_d+2*pr_wall, h=pr_height, center=true);
          }
        }
      }
      //Mount screw holes
      translate([mount_screws_distance/2, mount_screws_height-tm_height/2, 0]){
        cylinder(d=M4, h=tm_wall * 1.1, center=true);
      }
      translate([-mount_screws_distance/2, mount_screws_height-tm_height/2, 0]){
        cylinder(d=M4, h=tm_wall * 1.1, center=true);
      }
      //Pen hole
      translate([0, 0, pen_d/2+pr_wall]){
        rotate([0, 90, 90]){
          cylinder(d=pen_d, h=tm_height*1.1, center=true);
        }
      }
      //Pen adjust screw holes
      translate([0, (tm_height-pr_height)/2, pen_d/2+pr_wall]){
        rotate([0, 60, 0]){
          translate([0, 0, (pen_d+2*pr_wall)/2]){
            cylinder(d=M3_teight, h=pen_d+2*pr_wall, center=true);
          }
        }
        rotate([0, -60, 0]){
          translate([0, 0, (pen_d+2*pr_wall)/2]){
            cylinder(d=M3_teight, h=pen_d+2*pr_wall, center=true);
          }
        }
      }

      translate([0, tm_edge-(tm_height-pr_height)/2, pen_d/2+pr_wall]){
        rotate([0, 60, 0]){
          translate([0, 0, (pen_d+2*pr_wall)/2]){
            cylinder(d=M3_teight, h=pen_d+2*pr_wall, center=true);
          }
        }
        rotate([0, -60, 0]){
          translate([0, 0, (pen_d+2*pr_wall)/2]){
            cylinder(d=M3_teight, h=pen_d+2*pr_wall, center=true);
          }
        }
      }


    }
  }

}

module clamp_square(c_w = 60, c_h = 20, s_shift = 0){
  c_wall = 5;
  c_screw_d = c_w-8;
  c_gap = 3;

  tube_o = tube_e+buckles_h*2+c_wall*2;
  tube_i = tube_e+buckles_h*2;
  c_shift_z = sqrt(tube_i*tube_i/2)+c_wall;
  


  if(show_pen == 1){
    //Square tube
    translate([0, 0, c_shift_z]){
      rotate([0, 45, 0]){
        cube(size=[tube_e, c_h*1.1, tube_e], center=true);
      }
    }
  }

  difference(){
    union(){
      translate([0, 0, c_wall/2]){
        round_cube(c_w, c_h, c_wall, 6);
      }
      translate([0, 0, c_shift_z]){
        a=sqrt(2*tube_i*tube_i);
        cube(size=[a, c_h, a], center=true);
      }
    }
    //Inner tube hole
    translate([0, 0, c_shift_z]){
      rotate([0, 45, 0]){
        cube(size=[tube_i, c_h*1.1, tube_i], center=true);
      }
    }
    //Upper cut
    translate([0, 0, c_shift_z*2-c_gap]){
      cube(size=[c_w, c_h*1.1,c_shift_z*2], center=true);
    }
    //Lower cut
    translate([0, 0, -c_wall/2]){
      cube(size=[c_wall, c_h*1.1,c_wall], center=true);
    }

    //Screw holes
    translate([-c_screw_d/2, s_shift, c_wall/2]){
      cylinder(d=M4, h=c_wall*1.1, center=true);
    }
    translate([c_screw_d/2, s_shift, c_wall/2]){
      cylinder(d=M4, h=c_wall*1.1, center=true);
    }

  }

  a1=tube_e/2+buckles_h;
  a=sqrt(a1*a1/2);
  for(i=[0:1:1]){
    translate([(-1+2*i)*a, 0, a+c_wall]){
      rotate([0, 45-i*90, 0])
      translate([(1-i*2)*buckles_shift, 0, -buckles_r]){
        rotate([0, 90, 0]){
          difference(){
            union(){
              cylinder(r=buckles_r, h=buckles_w, center=true);
              rotate_extrude(){
                translate([buckles_r, 0, 0]){
                  circle(d=buckles_w, center=true);
                }
              }
            }
            translate([0, (buckles_r+c_h)/2, 0]){
              a=buckles_r*2.5;
              b=buckles_r;
              c=buckles_w*1.1;
              cube(size=[a, b, c], center=true);
            }
            translate([0, -(buckles_r+c_h)/2, 0]){
              a=buckles_r*2.5;
              b=buckles_r;
              c=buckles_w*1.1;
              cube(size=[a, b, c], center=true);
            }
            translate([buckles_h+0.1, 0, 0]){
              a=(buckles_r+buckles_h)*2;
              b=c_h*1.1;
              c=buckles_w*1.1;
              cube(size=[a, b, c], center=true);
            }
          }
        }
      }
    }
  }

}

module pen_holder_advanced(type = 2){
  tm_width = 34;
  tm_wall = 5;
  tm_height = 100;
  c_h = 35;
  mount_screws_distance = 31;
  mount_screws_height = 25;
  
  tube_o = tube_e+buckles_h*2+tm_wall*2;
  tube_i = tube_e+buckles_h*2;
  c_shift_z = sqrt(tube_i*tube_i/2)+tm_wall;

  
  difference(){
    union(){
      translate([0, 0, tm_wall/2]){
        cube(size=[tm_width, tm_height-2*c_h, tm_wall], center=true);
      }
      translate([0, (tm_height-c_h)/2, 0]){
        clamp_square(52, c_h);
      }
      translate([0, -(tm_height-c_h)/2, 0]){
        clamp_square(52, c_h, s_shift = -9);
      }
      //if(type == 2){//Side walls
        a = tm_wall;
        b = tm_height-2*c_h+2*tm_wall;
        c = 10;
        d = (tm_width-tm_wall)/2;
        translate([d, 0, c/2+tm_wall]){
          cube(size=[a, b, c], center=true);
        }
        translate([-d, 0, c/2+tm_wall]){
          cube(size=[a, b, c], center=true);
        }
      //}
    }
    if(type == 1){
      //Mount screw holes
      translate([mount_screws_distance/2, mount_screws_height-tm_height/2, tm_wall/2]){
        cylinder(d=M4, h=100, center=true);
      }
      translate([-mount_screws_distance/2, mount_screws_height-tm_height/2, tm_wall/2]){
        cylinder(d=M4, h=100, center=true);
      }
      translate([mount_screws_distance/2, mount_screws_height-tm_height/2, tm_wall+50]){
        cylinder(d=8, h=100, center=true);
      }
      translate([-mount_screws_distance/2, mount_screws_height-tm_height/2, tm_wall+50]){
        cylinder(d=8, h=100, center=true);
      }
    }
    if(type == 2){
      //Mount screw holes
      translate([mount_screws_distance/2, mount_screws_height-tm_height/2, tm_wall/2]){
        cylinder(d=8, h=100, center=true);
      }
      translate([-mount_screws_distance/2, mount_screws_height-tm_height/2, tm_wall/2]){
        cylinder(d=8, h=100, center=true);
      }
    }
  }


}


module round_cube(l=60, w=50, h=5, r=5){
  
  cube(size=[l-2*r, w, h], center=true);
  translate([(l-r)/2, 0, 0]){
    cube(size=[r, w-2*r, h], center=true);
  }
  translate([-(l-r)/2, 0, 0]){
    cube(size=[r, w-2*r, h], center=true);
  }
  translate([l/2-r, w/2-r, 0]){
    cylinder(r=r, h=h, center=true);
  }
  translate([-(l/2-r), w/2-r, 0]){
    cylinder(r=r, h=h, center=true);
  }
  translate([-(l/2-r), -(w/2-r), 0]){
    cylinder(r=r, h=h, center=true);
  }
  translate([l/2-r, -(w/2-r), 0]){
    cylinder(r=r, h=h, center=true);
  }  
}


module long_hole(diameter = 4, length = 2, height = 6){
  translate([length/2, 0, 0]){
    cylinder(d=diameter, h=height, center=true);
  }
  cube(size=[length, diameter, height], center=true);
  translate([-length/2, 0, 0]){
    cylinder(d=diameter, h=height, center=true);
  }
}


